#pragma once
#include "wmpacket.h"

/** Packet Class that carries location information

*** TODO is CoordPacket the same as WMAreaPacket???

	@ingroup data
*/
class CoordPacket :
	public WMAreaPacket
{
public:
	virtual PacketPointer Clone() const;
	CoordPacket &operator=(const CoordPacket &other);

	virtual size_t getHeapUsage() { return 0;	};
	virtual int getType() { return WMP_coord; };
	virtual char *getTypeName() { return "Coordinate"; };
	virtual bool queryType(const int type);	

	virtual bool canSerialize() { return false; };
	virtual bool Load(std::istream &) { assert(false); return false; };	
	virtual bool Save(std::ostream &) { assert(false); return false; };	

	virtual dword Color() { return 0x0ffff00; };
	virtual void Clear();

	CoordF get() { return location; };
	void set(CoordF &_l) { location = _l; };

//	PacketContext &getContext() { return sd; };

protected:
	friend class WMPacketFactory;
	CoordPacket();
	virtual ~CoordPacket();
	virtual void resetContents() { };

	CoordF	location;		// coordinates
	int coord_mode;			// 0 = world, 1 = local
};

/// Safe Packet Cast function 
/// @relates CoordPacket
inline CoordPointer LOC(PacketPointer const & pack) { 
	if (pack) {
		bool ok = pack->getType() == WMP_coord;
		assert(ok);
		if (!ok)
			return NULL;
	}
	return CoordPointer((CoordPacket*) pack.get()); 
};
